unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, T_BLOCK, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    L: TLabel;
    Label4: TLabel;
    TrackBar1: TTrackBar;
    N: TLabel;
    b: TBLOCK;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label5: TLabel;
    TrackBar2: TTrackBar;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Private declarations }
    help:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 Case key of
  'n','N':begin
           HELP:=3;
           TIMER1.INTERVAL:=1001;
           TRACKBAR2.POSITION:=3;
           B.NEW_GAME;
           TIMER1.ENABLED:=TRUE;
          end;
  '2':B.SEND_BOTTOM;
  '4':B.MOVE_LEFT;
  '5':B.ROTATE;
  '6':B.MOVE_RIGHT;
  #32:IF HELP>0 THEN
       IF B.HELP_ME THEN
        BEGIN
         DEC(HELP);
         TRACKBAR2.POSITION:=HELP;
         B.UPDATE;
        END;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Case B.MOVE_DOWN OF
  0:LABEL1.CAPTION:='Plaing...';
  1:BEGIN
     label1.caption:='Changing Piece...';
     IF B.NUMBEROFPIECES MOD 5 =0 THEN
      BEGIN
       IF TRACKBAR1.POSITION<14 THEN
        BEGIN
         TRACKBAR1.POSITION:=TRACKBAR1.POSITION+1;
         B.NUMBEROFCOLORS:=TRACKBAR1.POSITION;
        END
       ELSE
        BEGIN
         IF TIMER1.INTERVAL>150 THEN
          TIMER1.INTERVAL:=TIMER1.INTERVAL-50;
        END;
      END;
    END;
  2:begin
     label1.caption:='End of game.';
     timer1.enabled:=false;
    end;
 end;
 label1.update;
 LABEL2.CAPTION:=INTTOSTR(B.NUMBEROFPIECES);
 LABEL3.CAPTION:=INTTOSTR(B.LASTDELETEDPIECES);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 b.numberofcolors:=trackbar1.position
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 b.shownextpiece:=checkbox1.checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 b.showfillcolor:=checkbox2.checked;
 b.showbordercolor:=checkbox3.checked;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
 HELP:=TRACKBAR2.POSITION;
end;

end.
