unit T_BLOCK;


// DATA:      INIZIO:    FINE:      LAVORO:
//
//  13-07-97,  04:18:16   ??:??:??,  TROPPO STANCO PER CONCLUDERE
//                                   QUALCOSA DI BUONO...
//  14-07-97,  01:36:10,  03:44:05,  QUASI FINITO.
//  29-08-97,  00:54:11,  04:09:58,  AGGIUNTO LA PREVIEW FORM.
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,winprocs,
  wintypes,extctrls;

CONST
 LINES=24;
 COLUMNS=17;
 COLORI:ARRAY[0..15] OF TCOLOR = (CLBLACK,CLMAROON,CLGREEN,CLOLIVE,CLNAVY,
                                CLPURPLE,CLTEAL,CLGRAY,CLSILVER,CLRED,
                                CLLIME,CLYELLOW,CLBLUE,CLFUCHSIA,
                                CLAQUA,CLWHITE);
type
  TBlockType    = (btRound, btSquare, btButton, btBeveled);
  TBLOCK=class(TGraphicControl)
  private
   { Private declarations }
   Piece:ARRAY[1..2,0..2] OF TCOLOR;
   LX,LY,CX,CY:INTEGER;
   SIL,SFC:BOOLEAN;
   Vet:array[0..COLUMNS,0..LINES,1..2] of TCOLOR;
   P_COUNT:INTEGER;
   DELETEDL:INTEGER;
   NCOLORI:INTEGER;
   SQX:INTEGER;
   P_CAPT:TCAPTION;
   snp:boolean;
   F_PREW:TFORM;   //FORM PREW
   P_SIZE:INTEGER; //DIMENSIONI PREW
   fBlockType:TBlockType;
//   fBitmap:TBitmap;
   PROCEDURE DISEGNA_PEZZ(CONST X,Y:INTEGER;CONST VEDI:BOOLEAN);
   PROCEDURE VUOTA_COLONNA(CONST G:INTEGER);
   FUNCTION CHECK_FULL:BOOLEAN;
   PROCEDURE SAVE_POSITION;
   PROCEDURE SHOW_PREW;

   PROCEDURE SET_SNP(VALUE:BOOLEAN);
   PROCEDURE SET_SQUARE_DIM(VALUE:INTEGER);
   PROCEDURE SET_NCOLORI(VALUE:INTEGER);
   PROCEDURE NOT_(VALUE:INTEGER);
   PROCEDURE SET_CAPTION(VALUE:TCAPTION);
   PROCEDURE SET_P_SIZE(S:INTEGER);
   procedure fSetBlockType(B:TBlockType);
//   procedure fSetBitmap(Value: TBitmap);
  protected
    { Protected declarations }
   procedure Paint; override;
  public
    { Public declarations }
   FUNCTION MOVE_DOWN:INTEGER;
   FUNCTION MOVE_LEFT:BOOLEAN;
   FUNCTION MOVE_RIGHT:BOOLEAN;
   FUNCTION HELP_ME:BOOLEAN;
   FUNCTION SEND_BOTTOM:INTEGER;
   PROCEDURE NEW_GAME; // INIZIALIZZA IL GIOCO
   PROCEDURE ROTATE;
  published
    { Published declarations }
   Constructor Create(AOwner:TComponent); OVERRIDE;
   PROPERTY NumberOfPieces:INTEGER READ P_COUNT WRITE NOT_;
   PROPERTY LastDeletedPieces:INTEGER READ DELETEDL WRITE NOT_;
   PROPERTY NumberOfColors:INTEGER READ NCOLORI WRITE SET_NCOLORI;
   PROPERTY ShowBorderColor:BOOLEAN READ SIL WRITE SIL;
   PROPERTY ShowFillColor:BOOLEAN READ SFC WRITE SFC;
   PROPERTY ShowNextpiece:BOOLEAN READ SNP WRITE SET_SNP;
   PROPERTY SquareDimension:INTEGER READ SQX WRITE SET_SQUARE_DIM;
   PROPERTY PreviewSize:INTEGER READ P_SIZE WRITE SET_P_SIZE;
   PROPERTY PreviewCaption:TCAPTION READ P_CAPT WRITE SET_CAPTION;
   property BlockType: TBlockType read fBlockType write fSetBlockType default btRound;
 //  property BackBitmap: TBitmap read fBitmap write fSetBitmap;
 end;

procedure Register;

implementation

procedure TBLOCK.fSetBlockType(B:TBlockType);
begin
 fBlockType:=B;
 Paint;
end;

//procedure TBLOCK.fSetBitmap(Value: TBitmap);
//Begin
 //FBitmap.Assign(Value);
// Invalidate;
//End;

PROCEDURE TBLOCK.SET_SQUARE_DIM(VALUE:INTEGER);
 BEGIN
  SQX:=VALUE;
  HEIGHT:=SQX*LINES;
  WIDTH:=SQX*COLUMNS;
 END;

PROCEDURE TBLOCK.SET_CAPTION(VALUE:TCAPTION);
 BEGIN
  P_CAPT:=VALUE;
  F_PREW.CAPTION:=VALUE;
 END;

PROCEDURE TBLOCK.SET_SNP(VALUE:BOOLEAN);
 BEGIN
  SNP:=VALUE;
  IF SNP THEN
   F_PREW.SHOW
  ELSE
   F_PREW.CLOSE;
 END;

PROCEDURE TBLOCK.SHOW_PREW;
 VAR
  EX,A:INTEGER;
 BEGIN
  F_PREW.CANVAS.Pen.Color:=COLORI[0];
  F_PREW.CANVAS.BRUSH.Color:=COLORI[0];
  FOR A:=0 TO 2 DO
   BEGIN
    IF SIL THEN
     F_PREW.CANVAS.Pen.Color:=PIECE[2,A];
    IF SFC THEN
     F_PREW.CANVAS.BRUSH.Color:=PIECE[2,A];
    EX:=5+A*P_SIZE;
    F_PREW.CANVAS.Rectangle(EX,5,EX+P_SIZE,5+P_SIZE);
   END;
 END;

PROCEDURE Tblock.SET_P_SIZE(S:INTEGER);
 BEGIN
  IF (S>2) AND (S<>P_SIZE) THEN
   BEGIN
    P_SIZE:=S;
    F_PREW.CLIENTWIDTH:=3*S+10;
    F_PREW.CLIENTHEIGHT:=S+10;
   END;
 END;

PROCEDURE TBLOCK.SET_NCOLORI(VALUE:INTEGER);
 BEGIN
  IF VALUE IN [5..14] THEN
   NCOLORI:=VALUE
  ELSE
   SHOWMESSAGE('Invalid property value...');
 END;

PROCEDURE TBLOCK.NOT_(VALUE:INTEGER);
 BEGIN
  //SHOWMESSAGE('This is a read only property..');
 END;

PROCEDURE TBLOCK.NEW_GAME;
 VAR
  A,B:INTEGER;
 BEGIN
  P_COUNT:=0;
  CX:=COLUMNS DIV 2;
  CY:=0;
  RANDOMIZE;
  IF RANDOM(10)=0 THEN
   SHOWMESSAGE('Bianchini Marco'+#13+'E-Mail bianco@arcanet.it');
  DELETEDL:=0;
  P_COUNT:=0;
  FOR A:=1 TO 2 DO
   FOR B:=0 TO 2 DO
    Piece[A,B]:=COLORI[RANDOM(NCOLORI)+1];
  SHOW_PREW;
  FOR A:=0 TO COLUMNS DO
   FOR B:=0 TO LINES DO
    BEGIN
     VET[A,B,1]:=COLORI[0];
     VET[A,B,2]:=0;
    END;
  DISEGNA_PEZZ(CX,CY,TRUE);
 END;

FUNCTION TBLOCK.MOVE_LEFT:BOOLEAN;
 VAR
  RE:BOOLEAN;
 BEGIN
  IF CX>0 THEN
   RE:=(VET[CX-1,CY,1]=COLORI[0]) AND
       (VET[CX-1,CY+1,1]=COLORI[0]) AND
       (VET[CX-1,CY+2,1]=COLORI[0])
  ELSE
   RE:=FALSE;
  IF RE THEN
   BEGIN
    DISEGNA_PEZZ(CX,CY,FALSE);
    CX:=CX-1;
    DISEGNA_PEZZ(CX,CY,TRUE);
   END;
  MOVE_LEFT:=RE;
 END;

FUNCTION TBLOCK.HELP_ME:BOOLEAN;
 BEGIN
  IF PIECE[2,0]<>COLORI[15] THEN
   BEGIN
    PIECE[2,0]:=COLORI[15];
    HELP_ME:=TRUE;
    DISEGNA_PEZZ(CX,CY,TRUE);
    SHOW_PREW;
   // PAINT;
   END
  ELSE
   HELP_ME:=FALSE;
 END;

function TBLOCK.SEND_BOTTOM:INTEGER;
 VAR
  A:INTEGER;
 BEGIN
  A:=0;
  DISEGNA_PEZZ(CX,CY,FALSE);
  IF NOT ((CY=LINES-3) OR (VET[CX,CY+3,1]<>COLORI[0])) THEN
   REPEAT
    INC(A);
    INC(CY);
   UNTIL (CY>=LINES-3) OR (VET[CX,CY+3,1]<>COLORI[0]);
  IF CY>LINES-3 THEN
   CY:=LINES-3;
  DISEGNA_PEZZ(CX,CY,TRUE);
  SEND_BOTTOM:=A;
 END;

FUNCTION TBLOCK.MOVE_RIGHT:BOOLEAN;
 VAR
  RE:BOOLEAN;
 BEGIN
  IF CX<COLUMNS-1 THEN
   RE:=(VET[CX+1,CY,1]=COLORI[0]) AND
       (VET[CX+1,CY+1,1]=COLORI[0]) AND
       (VET[CX+1,CY+2,1]=COLORI[0])
  ELSE
   RE:=FALSE;
  IF RE THEN
   BEGIN
    DISEGNA_PEZZ(CX,CY,FALSE);
    CX:=CX+1;
   END;
  DISEGNA_PEZZ(CX,CY,TRUE);
  MOVE_RIGHT:=RE;
 END;

PROCEDURE TBLOCK.ROTATE;
 VAR
  A:TCOLOR;
  B:INTEGER;
 BEGIN
  FOR B:=1 TO 2 DO
   BEGIN
    A:=PIECE[B,0];
    PIECE[B,0]:=PIECE[B,1];
    PIECE[B,1]:=PIECE[B,2];
    PIECE[B,2]:=A;
    DISEGNA_PEZZ(CX,CY,TRUE);
    SHOW_PREW;
   END;
 END;

FUNCTION TBLOCK.MOVE_DOWN:INTEGER;
 VAR
  A:INTEGER;
 BEGIN
  IF (CY=LINES-3) OR (VET[CX,CY+3,1]<>COLORI[0]) THEN
   BEGIN
    //IL PEZZO DEVE FERMARSI
    MOVE_DOWN:=1;
    DISEGNA_PEZZ(CX,CY,TRUE);
    SAVE_POSITION;
    //VUOTA LE EVENTUALI COMBINAZIONI
    REPEAT
    UNTIL NOT CHECK_FULL;
    //CONTROLLA CHE SIA POSSIBILE CONTINUARE A GIOCARE
    IF VET[COLUMNS DIV 2,1,1]<>COLORI[0] THEN
     MOVE_DOWN:=2
    ELSE
     BEGIN
      //DATO CHE PUOI CONTINUARE MA IL PEZZO E'
      //FERMO NE CREI UN'ALTRO
      FOR A:=0 TO 2 DO
       BEGIN
        Piece[1,A]:=PIECE[2,A];
        Piece[2,A]:=COLORI[RANDOM(NCOLORI)+1];
       END;
      INC(P_COUNT);
      CX:=COLUMNS DIV 2;
      CY:=0;
      SHOW_PREW;
      DISEGNA_PEZZ(CX,CY,TRUE);
     END;
   END
  ELSE
   BEGIN //IL PEZZO CONTINUA A SCENDERE...
    DISEGNA_PEZZ(CX,CY,FALSE);
    INC(CY);
    DISEGNA_PEZZ(CX,CY,TRUE);
    MOVE_DOWN:=0;
   END;
 END;

PROCEDURE TBLOCK.DISEGNA_PEZZ(CONST X,Y:INTEGER;CONST VEDI:BOOLEAN);
 VAR
  EX,EY,A:INTEGER;
 BEGIN
  Canvas.Pen.Color:=COLORI[0];
  Canvas.BRUSH.Color:=COLORI[0];
  FOR A:=0 TO 2 DO
   BEGIN
    IF VEDI THEN
     BEGIN
      IF SIL THEN
       Canvas.Pen.Color:=PIECE[1,A];
      IF SFC THEN
       Canvas.BRUSH.Color:=PIECE[1,A];
     END;
    EX:=X*LX;
    EY:=Y*LY+A*LY;
    Canvas.Rectangle(EX,EY,EX+LX,EY+LY);
   END;
 END;

PROCEDURE TBLOCK.SAVE_POSITION;
 VAR
  A,C:INTEGER;
  B:LONGINT;
 BEGIN
  FOR A:=0 TO 2 DO
   VET[CX,A+CY,1]:=PIECE[1,A];
  B:=COLORI[0];
  FOR A:=0 TO 2 DO
   IF A+CY+1<=LINES THEN
    IF PIECE[1,A]=COLORI[15] THEN
    // BEGIN
     B:=VET[CX,A+CY+1,1];
    //  VET[CX,A+CY,1]:=COLORI[0];
    // END;
  IF B<>COLORI[0] THEN
   BEGIN
    FOR A:=0 TO COLUMNS DO
     FOR C:=0 TO LINES DO
      IF Vet[A,C,1] = B THEN
       Vet[A,C,2]:=1;
    FOR A:=0 TO COLUMNS DO
     VUOTA_COLONNA(A);
    FOR A:=0 TO COLUMNS DO
     FOR C:=0 TO LINES DO
      VET[A,C,2]:=0;
    REPEAT
     // ...
    UNTIL not CHECK_FULL;
    FOR A:=0 TO 2 DO
     IF PIECE[1,A]=COLORI[15] THEN
      PAINT;
  END;
 END;

 PROCEDURE TBLOCK.VUOTA_COLONNA(CONST G:INTEGER);
  VAR
   A,Y:INTEGER;
   BOOL:BOOLEAN;
  BEGIN
   REPEAT
    BOOL:=FALSE;
    //TROVA IL PEZZO DA CANCELLARE
    A:=LINES+1;
    REPEAT
     A:=A-1;
    UNTIL (A=0) OR (VET[G,A,2]=1);
    IF A>0 THEN
     BEGIN
      FOR Y:=A DOWNTO 1 DO
       BEGIN
        VET[G,Y,1]:=VET[G,Y-1,1];
        VET[G,Y,2]:=VET[G,Y-1,2];
       END;
      BOOL:=TRUE;
      VET[G,0,1]:=COLORI[0];//VET[G,Y-1,1];
      VET[G,0,2]:=0;
     END;
   UNTIL BOOL=FALSE;
  END;

FUNCTION TBLOCK.CHECK_FULL:BOOLEAN;
 VAR
  B:BOOLEAN;
  X,Y:INTEGER;
 BEGIN
  B:=FALSE;
  //VERTICALE
  FOR X:=0 TO COLUMNS DO
   FOR Y:=0 TO LINES-2 DO
    IF (VET[X,Y,1]=VET[X,Y+1,1]) AND
       (VET[X,Y,1]=VET[X,Y+2,1]) AND
       (VET[X,Y,1]<>COLORI[0]) THEN
     BEGIN
      VET[X,Y,2]:=1;
      VET[X,Y+1,2]:=1;
      VET[X,Y+2,2]:=1;
      B:=TRUE;
      INC(DELETEDL);
     END;
  //ORIZZONTALE
  FOR X:=0 TO COLUMNS-2 DO
   FOR Y:=0 TO LINES DO
    IF (VET[X,Y,1]=VET[X+1,Y,1]) AND
       (VET[X,Y,1]=VET[X+2,Y,1]) AND
       (VET[X,Y,1]<>COLORI[0]) THEN
     BEGIN
      INC(DELETEDL);
      VET[X,Y,2]:=1;
      VET[X+1,Y,2]:=1;
      VET[X+2,Y,2]:=1;
      B:=TRUE;
     END;
  // \
  FOR X:=0 TO COLUMNS-2 DO
   FOR Y:=0 TO LINES-2 DO
    IF (VET[X,Y,1]=VET[X+1,Y+1,1]) AND
       (VET[X,Y,1]=VET[X+2,Y+2,1]) AND
       (VET[X,Y,1]<>COLORI[0]) THEN
     BEGIN
      INC(DELETEDL);
      VET[X,Y,2]:=1;
      VET[X+1,Y+1,2]:=1;
      VET[X+2,Y+2,2]:=1;
      B:=TRUE;
     END;
  // /
  FOR X:=0 TO COLUMNS-2 DO
   FOR Y:=2 TO LINES DO
    IF (VET[X,Y,1]=VET[X+1,Y-1,1]) AND
       (VET[X,Y,1]=VET[X+2,Y-2,1]) AND
       (VET[X,Y,1]<>COLORI[0]) THEN
     BEGIN
      INC(DELETEDL);
      VET[X,Y,2]:=1;
      VET[X+1,Y-1,2]:=1;
      VET[X+2,Y-2,2]:=1;
      B:=TRUE;
     END;
  IF B THEN
   BEGIN
    // ELIMINA
    FOR X:=0 TO COLUMNS DO
     VUOTA_COLONNA(X);
    FOR X:=0 TO COLUMNS DO
     FOR Y:=0 TO LINES DO
      VET[X,Y,2]:=0;
   END;
  if b then
   paint;
  CHECK_FULL:=B;
 END;

procedure TBLOCK.PAINT;
 VAR
  A,B:INTEGER;
 BEGIN
  inherited Paint;
  LX:=WIDTH DIV COLUMNS;
  LY:=HEIGHT DIV LINES;
  Canvas.Pen.Color:=COLORI[0];
  Canvas.BRUSH.Color:=COLORI[0];
  CANVAS.Rectangle(0,0,Width,Height);
//  If fBitmap<>nil then
//   Canvas.StretchDraw(ClientRect,fbitmap);
  FOR A:=0 TO COLUMNS DO
   FOR B:=0 TO LINES DO
    BEGIN
     IF SIL THEN
      Canvas.Pen.Color:=VET[A,B,1];
     IF SFC THEN
      Canvas.BRUSH.Color:=VET[A,B,1];
     Canvas.Rectangle(A*LX,B*LY,A*LX+LX,B*LY+LY);
    END;
 END;

//*********************************************
constructor TBLOCK.Create(AOwner:TComponent);
 BEGIN
  inherited Create(AOwner);
  Width:=COLUMNS*20;
  Height:=LINES*20;
  NCOLORI:=5;
  SFC:=TRUE;
  F_PREW:=TFORM.CREATE(SELF);
  F_PREW.HIDE;
  SET_P_SIZE(20);
  F_PREW.COLOR:=Colori[0];
  F_PREW.CAPTION:='Next';
  F_PREW.BORDERICONS:=[biSystemMenu];
  F_PREW.BORDERSTYLE:=bsToolWindow;
 end;

procedure Register;
begin
  RegisterComponents('Bianco', [TBLOCK]);
end;

end.
